macro NOP_1 { db $90	       }
macro NOP_2 { db $66, $90      }
macro NOP_3 { db $0F, $1F, $00 }


; v1.3.10.0: $00438FD0
@@: Patches.inline.fabs:
   fld	    dword [esp]
   fabs
.size = $ - @b


; v1.3.10.0: $00462C10, $00BD98A0, $00D4DD10
@@: Patches.inline.getter_this:
   mov	    eax, [ecx]
   NOP_3
.size = $ - @b


; v1.3.10.0: $0061FD50
@@: Patches.inline.getter_this_offset_4:
   mov	    eax, [ecx+4]
   NOP_2
.size = $ - @b


; v1.3.10.0: $0047CB90
@@: Patches.inline.getter_this_offset_8:
   mov	    eax, [ecx+8]
   NOP_2
.size = $ - @b


; v1.3.10.0: $004A6CE0
@@: Patches.inline.getter_this_offset_60:
   mov	    eax, [ecx+60]
   NOP_2
.size = $ - @b


; v1.3.10.0: $008CF820
@@: Patches.inline.getter_this_offset_96:
   mov	    eax, [ecx+96]
   NOP_2
.size = $ - @b


; v1.3.10.0: $0070C490
@@: Patches.inline.setter_this_offset_96:
   pop	    eax
   mov	    [ecx+96], eax
   NOP_1
.size = $ - @b


; v1.3.10.0: $00450E10
@@: Patches.inline.getter_useless:
   mov	    eax, ecx
   NOP_3
.size = $ - @b


; v1.3.10.0: $0110D760
@@: Patches.inline.sqrt_called:
   fsqrt
   NOP_3
.size = $ - @b


; v1.3.10.0: $0110D760
@@: Patches.inline.sqrt_jumped:
   fsqrt
   retn
   int3
   int3
.size = $ - @b


; v1.3.10.0: $004A68B0
@@: Patches.replace.determine_visiblity:
   mov	    eax, [esp+4]
   movups   xmm0, [ecx]
   movups   xmm1, [eax]

   movaps   xmm2, xmm0
   movaps   xmm3, xmm1

   mulps    xmm0, xmm1
   psrldq   xmm2, 3*4
   psrldq   xmm3, 3*4
   pslldq   xmm0, 1*4

   movaps   xmm1, xmm3
   haddps   xmm0, xmm0
   subps    xmm1, xmm2
   haddps   xmm0, xmm0

   ucomiss  xmm0, xmm1
   jna	    .isSmaller

   xor	    eax, eax
   addps    xmm2, xmm3
   ucomiss  xmm0, xmm2

   sbb	    eax, -1
   retn     4

   db 13 dup $CC
   .isSmaller:
      mov      eax, 2
      retn     4
.size = $ - @b


; v1.3.10.0: $0064DF40
@@: Patches.replace.dot_product:
   mov	    eax, [esp+4]
   movups   xmm0, [ecx]
   movups   xmm1, [eax]

   mulps    xmm0, xmm1
   pslldq   xmm0, 1*4

   haddps   xmm0, xmm0
   haddps   xmm0, xmm0

   movss    [esp-4], xmm0
   fld	    dword [esp-4]

   retn     4
.size = $ - @b


; v1.3.10.0: $004A6910
@@: Patches.replace.dot_product_minus_unknown:
   mov	    eax, [esp+4]
   movups   xmm0, [ecx]
   movups   xmm1, [eax]

   mulps    xmm0, xmm1
   pslldq   xmm0, 1*4

   haddps   xmm0, xmm0
   haddps   xmm0, xmm0

   movss    [esp-4], xmm0
   fld	    dword [esp-4]
   fsub     dword [ecx+12]

   retn     4
.size = $ - @b


; v1.3.10.0: $004932F0
@@: Patches.replace.getter_row_column:
   mov	    eax, [esp+4]
   mov	    edx, [esp+8]
   lea	    eax, [eax+2*eax]
   lea	    eax, [ecx+4*eax]
   fld	    dword [eax+4*edx]

   retn     8
.size = $ - @b


; v1.3.10.0: $00D6C400, $006DF650
@@: Patches.replace.getter_this_plus_12x:
   mov	    eax, [esp+4]
   lea	    eax, [eax+2*eax]
   shl	    eax, 2
   add	    eax, [ecx]

   retn     4
.size = $ - @b


; v1.3.10.0: $00795AD0
@@: Patches.replace.getter_this_plus_112x:
   mov	    eax, [esp+4]
   lea	    edx, [eax+eax]
   shl	    eax, 4
   sub	    eax, edx
   shl	    eax, 3
   add	    eax, [ecx]

   retn     4
.size = $ - @b


; v1.3.10.0: $00C96C90
@@: Patches.replace.initialize_object_A:
   push     esi
   push     edi

   mov	    esi, [esp+12]
   mov	    eax, [esi]
   mov	    [ecx+120], eax

   mov	    eax, [ecx+8]
   mov	    edi, [ecx+38]

   sub	    eax, edi
   sbb	    edx, edx
   and	    edx, eax
   add	    edi, edx

   mov	    edx, [ecx]
   lea	    edi, [esi+4*edi]

   NOP_2
   .startLoop:
      cmp      esi, edi
      je       .exitLoop

      add      esi, 4
      mov      eax, [esi]
      mov      [edx+96], eax
      add      edx, 112

      jmp      .startLoop

   db 15 dup $CC
   .exitLoop:
      pop      edi
      pop      esi

      retn     4
.size = $ - @b


; v1.3.10.0: $00C96C00
@@: Patches.replace.initialize_object_B:
   push     esi
   push     edi

   mov	    esi, [esp+12]
   mov	    eax, [ecx+120]
   mov	    [esi], eax

   mov	    eax, [ecx+8]
   mov	    edi, [ecx+38]

   sub	    eax, edi
   sbb	    edx, edx
   and	    edx, eax
   add	    edi, edx

   mov	    edx, [ecx]
   lea	    edi, [esi+4*edi]

   NOP_2
   .startLoop:
      cmp      esi, edi
      je       .exitLoop

      add      esi, 4
      mov      eax, [edx+96]
      mov      [esi], eax
      add      edx, 112

      jmp      .startLoop

   db 15 dup $CC
   .exitLoop:
      pop      edi
      pop      esi

      retn     4
.size = $ - @b


; v1.3.10.0: $0048B390
@@: Patches.replace.test_bit_01:
   test     dword [ecx+152], $00000001
   setnz    al
   retn
.size = $ - @b


; v1.3.10.0: $004A3D50
@@: Patches.replace.test_bit_02:
   test     dword [ecx+152], $00000002
   setnz    al
   retn
.size = $ - @b


; v1.3.10.0: $006254B0
@@: Patches.replace.test_bit_06:
   test     dword [ecx+152], $00000020
   setnz    al
   retn
.size = $ - @b


; v1.3.10.0: $0048B3B0
@@: Patches.replace.test_bit_11:
   test     dword [ecx+152], $00000400
   setnz    al
   retn
.size = $ - @b


; v1.3.10.0: $00709BC0
@@: Patches.replace.test_bit_12:
   test     dword [ecx+152], $00000800
   setnz    al
   retn
.size = $ - @b


; v1.3.10.0: $00E1FA90
@@: Patches.replace.test_bit_15:
   test     dword [ecx+152], $00004000
   setnz    al
   retn
.size = $ - @b


; v1.3.10.0: $00438800:
@@: Patches.replace.test_bit_16:
   test     dword [ecx+152], $00008000
   setnz    al
   retn
.size = $ - @b


; v1.3.10.0: $005387C0
@@: Patches.replace.test_bit_18:
   test     dword [ecx+152], $00020000
   setnz    al
   retn
.size = $ - @b


; v1.3.10.0: $007AD670
@@: Patches.replace.test_bit_21:
   test     dword [ecx+152], $00100000
   setnz    al
   retn
.size = $ - @b


; v1.3.10.0: $0051E490
@@: Patches.replace.test_bit_23:
   test     dword [ecx+152], $00400000
   setnz    al
   retn
.size = $ - @b


; v1.3.10.0: $0051E320
@@: Patches.replace.test_bit_27:
   test     dword [ecx+152], $04000000
   setnz    al
   retn
.size = $ - @b


; v1.3.10.0: $00E1FA30
@@: Patches.replace.test_bit_28:
   test     dword [ecx+152], $08000000
   setnz    al
   retn
.size = $ - @b


; v1.3.10.0: $0051E340
@@: Patches.replace.test_bit_30_zero:
   test    dword [ecx+152], $20000000
   setz    al
   retn
.size = $ - @b


; v1.3.10.0: $00445E50, $00D33E20
@@: Patches.replace.test_is_zero:
   cmp	    dword [ecx], 0
   setz     al
   retn
.size = $ - @b


; v1.3.10.0: $00E71D70
@@: Patches.replace.traverse_list:
   push     ebx
   push     esi
   push     edi

   mov	    ebx, [esp+20]
   mov	    edx, [ebx+4]
   mov	    edx, [edx+60]

   mov	    esi, [esp+16]
   lea	    esi, [ecx+4*esi]

   .nextItem:
      mov      edi, [esi]
      test     edi, edi
      jz       .exitLoop

      mov      eax, [edi+4]
      mov      eax, [eax+60]
      cmp      edx, eax
      jna      .exitLoop

      lea      esi, [edi+28]
      jmp      .nextItem

   .exitLoop:
      mov      [esi], ebx
      mov      [ebx+28], edi

      mov      ebx, ecx
      mov      ecx, [esp+16]
      mov      eax, 1
      shl      eax, cl
      or       [ebx+20], eax
      mov      ecx, ebx

      pop      edi
      pop      esi
      pop      ebx
      retn     8
.size = $ - @b
